package com.brilliance.isc.common.txnhold.handler;

import com.brilliance.isc.common.transaction.txnhold.vo.TxnHoldVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.List;

@Component
public class TxnHoldHandlerManager {

    @Autowired
    private SyswrnTxnHoldHandler syswrnTxnHoldHandler;

    @Autowired
    private OitedTxnHoldHandler oitedTxnHoldHandler;

    @Autowired
    private PtmmodTxnHoldHandler ptmmodTxnHoldHandler;

    @Autowired
    private RoimodTxnHoldHandler roimodTxnHoldHandler;

    @Autowired
    private MtabutTxnHoldHandler mtabutTxnHoldHandler;

    private List<ITxnHoldHandler> txnHoldHandlerList = null;

    @PostConstruct
    public void initHandlers() {
        txnHoldHandlerList = new ArrayList<>();
        txnHoldHandlerList.add(syswrnTxnHoldHandler);
        txnHoldHandlerList.add(oitedTxnHoldHandler);
        txnHoldHandlerList.add(ptmmodTxnHoldHandler);
        txnHoldHandlerList.add(roimodTxnHoldHandler);
        txnHoldHandlerList.add(mtabutTxnHoldHandler);
    }

    public void doHandler(TxnHoldVo txnHoldVo) {
        txnHoldHandlerList.forEach(handler -> handler.handleInterruptTransaction(txnHoldVo));
    }
}
